; $Id: dcstoolsperformance.pro,v 1.8 2002/11/01 22:17:14 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro DCSToolsPerformance_handler,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue=state
done=state.done
if (event.id eq done) then begin
	widget_control,event.top,/destroy
	return
endif
end


;************************************************************************************************
pro DCSToolsPerformance_mouseposition,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue=state
messagetext=state.messagetext
npsptr=state.npsptr
;
tracking=(tag_names(event,/structure_name) eq 'WIDGET_TRACKING')
;
fluxplot=state.fluxplot
fluxplot2=state.fluxplot2
resnplot=state.resnplot
conversion=state.conversion
crange=state.crange
;
; Respond to cursor.
;
if (event.id eq fluxplot) then iplot=0
if (event.id eq fluxplot2) then iplot=1
if (event.id eq resnplot) then iplot=2
;
if (tracking) then begin
;	if (event.enter) then print,'Entering window',iplot $
;		else print,'Exiting window',iplot
	return
endif
;
; Convert cursor device coordinates to normal coordinates.
x=CONVERT_COORD(event.x,event.y,/device,/to_normal)
;
; Convert normal coordinates to data coordinates.
wl=(x[0]-conversion[iplot,0])/conversion[iplot,1]
yn=(x[1]-conversion[iplot,2])/conversion[iplot,3]
;
value0=""
value1=""
value2=""
if (wl ge crange[iplot,0] and wl le crange[iplot,1]) then begin
	flux1=dcs_jcc_flux(wl,1,npsptr)
	flux2=dcs_jcc_flux(wl,2,npsptr)
	flux3=dcs_jcc_flux(wl,3,npsptr)
	mspeed=20000
	resn1=dcs_jcc_resn(wl,wl,1,mspeed)
	resn2=dcs_jcc_resn(wl,wl,2,mspeed)
	resn3=dcs_jcc_resn(wl,wl,3,mspeed)
	resn1a=13220/wl^2.947
	resn2a=3948/wl^2.656
;
	value0=[string(wl,format='("Wavelength:",(f8.3)," A")'),"",$
		"Neutrons at sample (n/s):","",$
		"  Low resolution (mode 1):"+string(flux1,format='(e10.2)'),"",$
		"  Medium resolution (mode 2):"+string(flux2,format='(e10.2)'),"",$
		"  High resolution (mode 3):"+string(flux3,format='(e10.2)')]
	value1=value0
	value2=[string(wl,format='("Wavelength:",(f8.3)," A")'),"",$
		"Elastic resolution (ueV)","  (model: fit to measurement):","",$
		"  Low resolution (mode 1):"+string(resn1,format='(f8.1)')+':'+string(resn1a,format='(f8.1)'),"",$
		"  Medium resolution (mode 2):"+string(resn2,format='(f8.1)')+':'+string(resn2a,format='(f8.1)'),"",$
		"  High resolution (mode 3):"+string(resn3,format='(f8.1)')]
	endif
widget_control,messagetext[0],set_value=value0
widget_control,messagetext[1],set_value=value1
widget_control,messagetext[2],set_value=value2
;
end


;************************************************************************************************
pro DCSToolsPerformance,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue=statePtr
davePtr=(*statePtr).davePtr
;
dcs_sysvars,davePtr=davePtr
;
tvlct,r,g,b,/get
rgbptr=ptr_new({r:r,g:g,b:b})
;
screensize=!screensize
;
xsz=screensize[0]
ysz=screensize[1]
messagetext=lonarr(3)
;
tlb=widget_base(title='Flux and Resolution at 20000 rpm',/row,$
	group_leader=event.top,/modal)
	plots=widget_base(tlb,/col)
		fluxbase=widget_base(plots,/row)
			fluxplot=widget_draw(fluxbase,xsize=0.5*xsz,ysize=0.32*ysz,$
				/tracking_events,/motion_events,event_pro='DCSToolsPerformance_mouseposition')
			messagetext[0]=widget_text(fluxbase,ysize=7,xsize=36,value="")
		fluxbase2=widget_base(plots,/row)
			fluxplot2=widget_draw(fluxbase2,xsize=0.5*xsz,ysize=0.32*ysz,$
				/tracking_events,/motion_events,event_pro='DCSToolsPerformance_mouseposition')
			messagetext[1]=widget_text(fluxbase2,ysize=6,xsize=36,value="")
		resnbase=widget_base(plots,/row)
			resnplot=widget_draw(resnbase,xsize=0.5*xsz,ysize=0.20*ysz,$
				/tracking_events,/motion_events,event_pro='DCSToolsPerformance_mouseposition')
			messagetext[2]=widget_text(resnbase,ysize=6,xsize=36,value="")
; Realize the widget
done=widget_button(plots,value='Done')
;
centertlb,tlb
widget_control,tlb,/realize
;
wlmin=1.0
wlmax=12.0
;
dcs_getnps,npsptr
;
dwl=0.05
nwl=(wlmax-wlmin)/dwl+1
wl=wlmin+findgen(nwl)*dwl
;
widget_control,fluxplot,get_value=winid
wset,winid

maxflux=max(dcs_jcc_flux(wl,1,npsptr))
minflux=maxflux*0.001
ylim=[minflux,maxflux]

; Save current color table.
oldct=dcs_getctinfo()
; Use Alan's routine to load 256 colors.
tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue

conversion=fltarr(3,4)
crange=fltarr(3,4)
;
; Plot the top frame.
plot,[0,12],ylim,xtitle='Wavelength (A)',ytitle='Neutrons at sample (n/s)',thick=2.0,$
	/nodata,/ynozero,/ylog,background=0,color=1
conversion[0,*]=[!x.s,!y.s]
crange[0,*]=[!x.crange,!y.crange]

for rmode=1,3 do begin
	flux=dcs_jcc_flux(wl,rmode,npsptr)
	oplot,wl,flux,color=rmode,thick=2.0
endfor
;
widget_control,fluxplot2,get_value=winid
wset,winid
;
; Plot the middle frame.
plot,[1,3],ylim,xtitle='Wavelength (A)',ytitle='Neutrons at sample (n/s)',thick=2.0,$
	/nodata,/ynozero,/ylog,background=0,color=1
conversion[1,*]=[!x.s,!y.s]
crange[1,*]=[!x.crange,!y.crange]
;
for rmode=1,3 do begin
	flux=dcs_jcc_flux(wl,rmode,npsptr)
	oplot,wl,flux,color=rmode,thick=2.0
endfor
;
widget_control,resnplot,get_value=winid
wset,winid
;
mspeed=20000
wli=wl
wlf=wl
minresn=min(dcs_jcc_resn(wl,wl,1,mspeed))*0.1
maxresn=max(dcs_jcc_resn(wl,wl,1,mspeed))
ylim=[minresn,maxresn]
;
; Plot the bottom frame.
plot,[0,12],ylim,xtitle='Wavelength (A)',ytitle='Resolution FWHM (ueV)',thick=2.0,$
	/nodata,/ynozero,/ylog,background=0,color=1
conversion[2,*]=[!x.s,!y.s]
crange[2,*]=[!x.crange,!y.crange]
;
for rmode=1,3 do begin
	resn=dcs_jcc_resn(wl,wl,rmode,mspeed)
	oplot,wl,resn,color=rmode,thick=2.0
endfor
resn1a=13220/wl^2.947
resn2a=3948/wl^2.656
oplot,wl,resn1a,color=1,thick=2.0,linestyle=3
oplot,wl,resn2a,color=2,thick=2.0,linestyle=3
;
; Revert to color table in existence at start of procedure.
tvlct,oldct
;
state={done:done,messagetext:messagetext,wlmin:wlmin,wlmax:wlmax,$
	conversion:conversion,crange:crange,npsptr:npsptr,$
	fluxplot:fluxplot,fluxplot2:fluxplot2,resnplot:resnplot}
widget_control,tlb,set_uvalue=state
;
xmanager,'DCSToolsPerformance',tlb,event_handler='DCSToolsPerformance_handler',$
	/no_block,group_leader=group_leader
;
dave_makeDavePtr,davePtr=davePtr
(*statePtr).davePtr=davePtr
;
tvlct,(*rgbptr).r,(*rgbptr).g,(*rgbptr).b
ptr_free,rgbptr
;
end
