; $Id: dcstoolsplanner.pro,v 1.14 2002/11/01 22:17:14 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro DCSToolsPlanner_exitbutton,event
;************************************************************************************************
;
compile_opt strictarr
;
; Respond to the "EXIT" button.  Destroy the widget.
;
widget_control,event.top,/destroy
end

;************************************************************************************************
pro DCSToolsPlanner_printbutton,event
;************************************************************************************************
;
compile_opt strictarr
;
; Respond to the "Print" button.
;
widget_control,event.top,GET_UVALUE=state
wl=state.wl
phimin=state.phimin
dphi=state.dphi
phimax=state.phimax
rat=state.rat
nef=state.nef
npsptr=state.npsptr
;
thisDevice = !d.name
;deviceKeywords = ps_form(Cancel = canceled,parent = event.top)
device_keywords = PSConfig(Cancel=canceled,group_leader = event.top)
if canceled ne 1 then begin
  SET_PLOT, 'PS'
  DEVICE, _Extra = deviceKeywords
  DCSToolsPlanner_plot_kar,wl,phimin,dphi,phimax,rat,nef,skip=1,npsptr
  DEVICE, /CLOSE_FILE
  set_plot,thisDevice
endif
;
end


;************************************************************************************************
pro DCSToolsPlanner_zoombutton,event
;************************************************************************************************
;
compile_opt strictarr
;
; Respond to the "Zoom in" button.
;
common zoom_related,x1,x2,x1r,x2r,drawzoom,dozoom,zoomed,zdrawn,xlim,ylim
;
widget_control,event.top,GET_UVALUE=state
wl=state.wl
phimin=state.phimin
dphi=state.dphi
phimax=state.phimax
rat=state.rat
nef=state.nef
npsptr=state.npsptr
;
dozoom=1
drawzoom=0
DCSToolsPlanner_plot_kar,wl,phimin,dphi,phimax,rat,nef,/skip,npsptr
dozoom=0
;
end


;************************************************************************************************
pro DCSToolsPlanner_t2ebutton_handler,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,/destroy
end


;************************************************************************************************
pro DCSToolsPlanner_t2ebutton,event
;************************************************************************************************
;
compile_opt strictarr
;
common modifiable_stuff,mspeed,rmode,israt,sdenom,tsdm,samperiod,nout,tchanmethod
;
; Respond to "Time to energy" button.
;
widget_control,event.top,get_uvalue=state
wl=state.wl
tchanmethod=state.tchanmethod
nout=state.nout
tsdmin=float(tsdm)
econvert=!dcs_hsq2mn/(!dcs_hom/!dcs_dsd)^2
tsd0=wl/!dcs_hom*!dcs_dsd
e0=econvert/tsd0^2
dt_VME=0.05
;nin=samperiod/dt_VME
;nin=round(nin)
;
tsdmax=tsdmin+samperiod
;
emax=econvert/tsdmin^2
emin=econvert/tsdmax^2
;
; This statement is included in order to force compilation of procedures in
; the file dcs_make_tlookup.pro
dcs_make_tlookup,-1.0
;
case tchanmethod of
	0: dcs_make_tlookup_fixed_dt,samperiod,nout,dt_VME,tsdmin,tstart,tstop
	1: dcs_make_tlookup_fixed_de,emin,emax,nout,econvert,dt_VME,tstart,tstop
	else: stop
endcase
;
minframe=-5
nframes=6
repeat begin
	tsdmaxframe=tsdmin+minframe*samperiod+samperiod
	minframe=minframe+1
endrep until tsdmaxframe gt 0.0
minframe=minframe-1
maxframe=minframe+nframes-1
nch=n_elements(tstart)
contents=strarr(nframes,nch+1)
for frame=minframe,maxframe do begin
	time=[tstart[0],tstop]+frame*samperiod
	contents[frame-minframe,*]=string(e0-econvert/time^2,format='(f8.3)')
	indices=where(time le 0.0,count)
	if (count gt 0) then contents[frame-minframe,indices]="---"
endfor
;
column_labels="Frame"+strcompress(string(indgen(nframes)+minframe))
row_labels=["Chn. 1 start","Chn."+strcompress(string(indgen(nch)+1))+" end"]
tlb=widget_base(title="Time channel to energy transfer",$
		/col,/modal,group_leader=event.top)
	rowb=widget_base(tlb,/row)
	leftb=widget_base(rowb,/col)
	void=widget_label(leftb,value="Wavelength ="+string(wl))
	void=widget_label(leftb,value="SR denominator ="+string(state.sdenom))
	rightb=widget_base(rowb,/col)
	void=widget_label(rightb,value="t_SDmin ="+string(tsdmin))
	void=widget_label(rightb,value="D_SD ="+string(!dcs_dsd))
	void=widget_label(tlb,value="Energy transfers in meV")
	void=widget_table(tlb,xsize=nframes,ysize=nch+1,$
		x_scroll_size=nframes,y_scroll_size=19,$
		column_widths=[intarr(nframes)+50,5],column_labels=column_labels,$
		alignment=1,row_labels=row_labels,value=contents)
	done=widget_button(tlb,value="DONE")
centertlb,tlb
geom=widget_info(tlb,/geometry)
widget_control,leftb,xsize=0.5*geom.xsize
widget_control,tlb,/realize
;
xmanager,"DCSToolsPlanner_t2ebutton",tlb,$
	event_handler="DCSToolsPlanner_t2ebutton_handler"
;
end


;************************************************************************************************
pro DCSToolsPlanner_tchanbutton,event
;************************************************************************************************
;
compile_opt strictarr
;
common modifiable_stuff,mspeed,rmode,israt,sdenom,tsdm,samperiod,nout,tchanmethod
;
; Respond to "Save tchan widths" button.
;
widget_control,event.top,get_uvalue=state
wl=state.wl
tchanmethod=state.tchanmethod
nout=state.nout
tsdmin=float(tsdm)
fname=dialog_pickfile(title='Name of file in which to save time channel widths',file='twid.dat',filter='*.dat')
warnings=strarr(20)
warnings[0]="No file written."
if (fname ne "") then begin
	dcs_make_tlookup,wl,samperiod,tchanmethod,nout,tsdmin,fname,imsg,nch
	if (imsg eq 0) then begin
		warnings[0]="File has been written."
		warnings[1:2]=["Total valid VME channels =",strcompress(long(total(nch[0:nout-1])))]
		warnings[3:4]=["Total of all VME channels =",strcompress(long(total(nch)))]
	endif else begin
		case imsg of
			1: warnings[1]="Unacceptable period."
	  	2: warnings[1:2]=["Unacceptable minimum ","t-o-f from sample to detector."]
			else:
		endcase
	endelse
endif
widget_control,state.warningstext,set_value=warnings
end


;************************************************************************************************
pro DCSToolsPlanner_mouseposition,event
;************************************************************************************************
;
compile_opt strictarr
;
; Respond to cursor, displaying E0-Ef and Q.
; Also display Ef if appropriate, and phi if appropriate.
;
common constants,conversion
common units,iunit,Aunit,unitname
common energies,e0
common modifiable_stuff,mspeed,rmode,israt,sdenom,tsdm,samperiod,nout,tchanmethod
common cursor_related,postext,restext
common zoom_related,x1,x2,x1r,x2r,drawzoom,dozoom,zoomed,zdrawn,xlim,ylim
;
widget_control,event.top,GET_UVALUE=state
npsptr=state.npsptr
;
; Convert cursor device coordinates to data coordinates.
x=CONVERT_COORD(event.x,event.y,/device,/to_data)
;
; If button was pressed capture its data coordinates (x1).
if (event.type eq 0) then begin
	x1=x
endif
;
; If button was released first capture its data coordinates (x2).
if (event.type eq 1) then begin
	x2=x
;	Determine button movement in device coordinates.
	dx=abs(x2-x1)
	dx00=CONVERT_COORD(0.0,0.0,/data,/to_device)
	dx=CONVERT_COORD(dx[0],dx[1],/data,/to_device)-dx00
; If the button's movement since it was pressed is "significant",
; draw a zoom rectangle.
; If the button's movement since it was pressed is not "significant"
; perform a zoom if not already zoomed and a zoom rectangle has been
; drawn, perform an unzoom if already zoomed.
	doplot=0
	significant=dx[0] gt 1.0 or dx[1] gt 1.0
	if (significant) then begin
		dozoom=0 & drawzoom=1 & doplot=1 & x1r=x1 & x2r=x2
	endif else begin
		if (zoomed) then begin
			dozoom=0 & drawzoom=0 & doplot=1 & endif
		if (zdrawn and not zoomed) then begin
			dozoom=1 & drawzoom=0 &	doplot=1 & x1=x1r & x2=x2r & endif
	endelse
	;
	; N.B. If all that's required is to draw a zoom rectangle it is best
	; to do it this way because there may already be a zoom rectangle
	; that must be erased. In other words the whole plot should be redrawn.
	if (doplot) then begin
		widget_control,event.top,GET_UVALUE=state
		wl=state.wl
		phimin=state.phimin
		dphi=state.dphi
		phimax=state.phimax
		rat=state.rat
		nef=state.nef
		DCSToolsPlanner_plot_kar,wl,phimin,dphi,phimax,rat,nef,skip=0,npsptr
	endif
endif
;
ptext=strarr(6)
rtext=strarr(2)
if (x[0] ge !x.crange[0] and x[0] le !x.crange[1] and $
    x[1] ge !y.crange[0] and x[1] le !y.crange[1]) then begin
; Define display information for E0-Ef and Q.
	ptext[0]='E0-Ef = '+string(x[0],format='(f8.3)')+' meV'
	ptext[1]='Q = '+string(x[1],format='(f6.3)')+' '+unitname[iunit]+'-1'
	rtext[0]='Energy Resolution'
;
; If Ef>0 define display information for Ef.
	ef=e0-x[0]
	q=x[1]/Aunit[iunit]
	if (ef gt 0.0) then begin
		ptext[2]='Ef = '+string(ef,format='(f6.3)')+' meV'
		cphi=(-q^2/conversion+e0+ef)/(2*sqrt(e0*ef))
; If computed cos(phi) satisfies -1<cos(phi)<1, define
; display information for phi.
		if (abs(cphi) le 1.0) then begin
			phi=acos(cphi)*180/!pi
			ptext[3]='phi = '+string(phi,format='(f6.2)')+' deg'
		endif
		wl0=sqrt(!dcs_hsq2mn/e0)
		wlf=sqrt(!dcs_hsq2mn/ef)
		eres=dcs_jcc_resn(wl0,wlf,rmode,mspeed)
		tsd=long(sqrt(!dcs_hsq2mn/ef)/!dcs_hom*!dcs_dsd)
		ptext[4]='tsd = '+string(tsd,format='(i6)')+' us'
		fraction=(tsd-tsdm)/samperiod
		frame=0
		while (fraction lt 0.0) do begin fraction=fraction+1.0 & frame=frame-1 & endwhile
		while (fraction ge 1.0) do begin fraction=fraction-1.0 & frame=frame+1 & endwhile
		if (tchanmethod eq 1) then begin
			etmin=e0-!dcs_hsq2mn/(!dcs_hom*tsdm/!dcs_dsd)^2
			etmax=e0-!dcs_hsq2mn/(!dcs_hom*(tsdm+samperiod)/!dcs_dsd)^2
			et=e0-!dcs_hsq2mn/(!dcs_hom*(tsdm+fraction*samperiod)/!dcs_dsd)^2
			fraction=(et-etmin)/(etmax-etmin)
		endif
		ptext[5]='Time channel'+string(fraction*nout,format='(i5)')+' ['$
			+string(frame,format='(i2)')+']'
		rtext[1]=string(eres,format='(f6.1)')+' ueV'
	endif
endif
;
; Update the display.
widget_control,postext,set_value=ptext
widget_control,restext,set_value=rtext
;
end


;************************************************************************************************
pro DCSToolsPlanner_textbuttons,event
;************************************************************************************************
;
compile_opt strictarr
;
; Respond to parameter changes, to the "Recalculate" button, to the "Save parameters" button, or
; to the "Restore parameters" button.
;
common units,iunit,Aunit,unitname
common modifiable_stuff,mspeed,rmode,israt,sdenom,tsdm,samperiod,nout,tchanmethod
common zoom_related,x1,x2,x1r,x2r,drawzoom,dozoom,zoomed,zdrawn,xlim,ylim
;
;Get information from widget.
widget_control,event.top,GET_UVALUE=state
;
saving=event.id eq state.savpb
restoring=event.id eq state.respb
otherwise=not saving and not restoring
npsptr=state.npsptr
;
if (restoring) then begin
	if (!operating_system eq "Windows") then $
		directory="c:\rsi\dave\dcs\text files\" else directory=""
	filename=dialog_pickfile(path=directory,$
		file="plannerfile.pln",/read,filter="*.pln",/fix_filter)
	if (filename ne "") then begin
		restore,filename=filename
		widget_control,state.unitsdroplist,set_droplist_select=planpar.iunit
		widget_control,state.lambdatext,set_value=string(planpar.wl)
		widget_control,state.rattext,set_value=string(planpar.erat)
		widget_control,state.phiminslider,set_value=string(planpar.phimin)
		widget_control,state.dphislider,set_value=string(planpar.dphi)
		widget_control,state.phimaxslider,set_value=string(planpar.phimax)
		widget_control,state.speedtext,set_value=string(planpar.ms)
		widget_control,state.sratdroplist,set_droplist_select=planpar.israt
		widget_control,state.srattext,set_value=string(planpar.sdenom)
		widget_control,state.rmodetext,set_value=string(planpar.rmode)
		widget_control,state.tsdmtext1,set_value=string(planpar.tsdm)
		widget_control,state.tsdmdroplist,set_droplist_select=planpar.dtmet
		widget_control,state.tsdmtext3,set_value=string(planpar.nout)
	endif
endif
;
; Read wavelength from widget. Also read choice of wavelength unit.
; Convert wavelength to Angstroms. Store in state variable.
widget_control,state.lambdatext,GET_VALUE=temp
wl_read=float(temp[0])
iunit=widget_info(state.unitsdroplist,/DROPLIST_SELECT)
wl=wl_read*Aunit[iunit]
state.wl=wl
;
; Read ratio (E0-Efmax)/E0, required to determine plot range. Store in state variable.
widget_control,state.rattext,GET_VALUE=temp
rat=float(temp[0])
state.rat=rat
;
; Read min, step and max values of phi. Store in state variable.
widget_control,state.phiminslider,GET_VALUE=temp
phimin=float(temp[0])
state.phimin=phimin
widget_control,state.dphislider,GET_VALUE=temp
dphi=float(temp[0])
state.dphi=dphi
widget_control,state.phimaxslider,GET_VALUE=temp
phimax=float(temp[0])
state.phimax=phimax
;
; Obtain number of final energies for the plot.
nef=state.nef
;
; Read chopper system master speed. Store in state variable.
widget_control,state.speedtext,GET_VALUE=temp
mspeed=fix(temp[0])
state.mspeed=mspeed
;
; Read resolution mode (should be 1, 2 or 3). Store in state variable.
widget_control,state.rmodetext,GET_VALUE=temp
rmode=fix(temp[0])
state.rmode=rmode
;
; Read chopper system frame overlap speed ratio denominator.
; Also read choice between '(m-1)/m' and '1/m' method of computing numerator.
; Store this choice and the denominator in state variable.
widget_control,state.srattext,GET_VALUE=temp
sdenom=temp[0]
israt=widget_info(state.sratdroplist,/DROPLIST_SELECT)
state.israt=israt
state.sdenom=sdenom
;
; Read minimum proposed time of flight from sample to detectors. Store in state variable.
widget_control,state.tsdmtext1,GET_VALUE=temp
tsdm=temp[0]
tsdmrat=tsdm/(6.0e7/mspeed)
if (abs(tsdmrat-round(tsdmrat)) lt 0.001) then begin
endif
state.tsdm=tsdm
;
; Read choice between 'constant dt' and 'constant dE' methods of computing time channels.
; Store this choice in state variable.
tchanmethod=widget_info(state.tsdmdroplist,/DROPLIST_SELECT)
state.tchanmethod=tchanmethod
;
; Read number of valid time channels. Store in state variable.
widget_control,state.tsdmtext3,GET_VALUE=temp
nout=temp[0]
state.nout=nout
;
if (saving) then begin
	planpar={iunit:iunit,wl:wl_read,erat:rat,phimin:phimin,dphi:dphi,phimax:phimax,$
	ms:mspeed,israt:israt,sdenom:sdenom,rmode:rmode,tsdm:tsdm,dtmet:tchanmethod,nout:nout}
	if (!operating_system eq "Windows") then $
		directory="c:\rsi\dave\dcs\text files\" else directory=""
	filename=dialog_pickfile(path=directory,$
		file="plannerfile.pln",/write,filter="*.pln",/fix_filter)
	if (filename ne "") then begin
	  if (strmid(filename,3,/reverse) ne ".pln") then filename=filename+".pln"
	  save,filename=filename,planpar
	endif
endif
;
; Call DCSToolsPlanner_plot_kar to plot the kinematically allowed region, etc.
dozoom=0
drawzoom=0
DCSToolsPlanner_plot_kar,wl,phimin,dphi,phimax,rat,nef,skip=0,npsptr
;
; Put information back into widget.
; (The DCSToolsPlanner_plot_kar routine [q.v.] may have modified some of the
; information from the widget.)
widget_control,event.top,SET_UVALUE=state
;
end


;************************************************************************************************
pro DCSToolsPlanner_plot_kar,wl,phimin,dphi,phimax,rat,nef,skip=skip,npsptr
;************************************************************************************************
;
compile_opt strictarr
;
; Plot kinematically allowed region, possibly modify some of the input parameters,
; generating warning messages, and compute and display useful derived quantities.
;
common constants,conversion
common units,iunit,Aunit,unitname
common energies,e0
common dependent_values,messagetext
common dependent_stuff,periodstext,elimitstext,warningstext
common modifiable_values,rattext,phiminslider,phimaxslider,$
	speedtext,rmodetext,srattext,tsdmtext1
common modifiable_stuff,mspeed,rmode,israt,sdenom,tsdm,samperiod,nout,tchanmethod
common zoom_related,x1,x2,x1r,x2r,drawzoom,dozoom,zoomed,zdrawn,xlim,ylim
;
; Save current color table.
oldct=dcs_getctinfo()
; Use Alan's routine to load 256 colors.
tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
;
e0=!dcs_hsq2mn/wl^2
;
; If necessary, redefine rat.
if (rat le 1.0) then rat=1.0
;
; If necessary swap phimin and phimax
if (phimin gt phimax) then begin
	phitemp=phimin
	phimin=phimax
	phimax=phitemp
endif
; Redefine phimax (its value may or may not change).
phimax=phimin+dphi*fix(round((phimax-phimin)/dphi))
if (phimax gt 180) then phimax=phimax-dphi
;
warnings=strarr(20)
iwarning=0
warnings[0]='WARNINGS/INFORMATION'
;
; Make sure master speed is between 1200 and 20000 rpm.
if (not (1200 le mspeed and mspeed le 20000)) then begin
	mspeed=1200>mspeed<20000
	iwarning=iwarning+1
	warnings[iwarning]='Illegal master speed --> corrected.'
endif
;
; Make sure resolution mode is 1, 2 or 3.
if (not (1 le rmode and rmode le 3)) then begin
	iwarning=iwarning+1
	warnings[iwarning]='Illegal resolution mode --> corrected.'
	rmode=1>rmode<3
endif
;
; Make sure speed ratio denominator is between 1 and 25.
; Compute speed ratio numerator.
if (not (1 le sdenom and sdenom le 25)) then begin
	iwarning=iwarning+1
	warnings[iwarning]='Illegal speed ratio denominator'
	iwarning=iwarning+1
	warnings[iwarning]='             --> corrected.'
	sdenom=1>sdenom<25
endif
if (sdenom lt 3) then snum=1 else begin
	if (israt eq 1) then snum=1 else snum=sdenom-1
endelse
;
; Compute master period.
mperiod=float(60*1e6/mspeed)
; Compute time between pulses at sample.
samperiod=mperiod*sdenom
; Compute period and speed of frame overlap chopper.
sc_period=samperiod/snum
sc_speed=float(60*1e6/sc_period)
if (not (1200 le sc_speed and sc_speed le 20000)) then begin
	iwarning=iwarning+1
	warnings[iwarning]='Illegal frame overlap chopper speed.'
	iwarning=iwarning+1
	warnings[iwarning]='*** Speed ratio has been reset to 1/1.'
	snum=1
	sdenom=1
	samperiod=mperiod
	sc_period=samperiod
	sc_speed=mspeed
endif
;
tsdm=fix(tsdm)
;
; Compute scattered neutron energies corresponding to
; first and last time channels.
ehigh=!dcs_hsq2mn/(!dcs_hom*tsdm/!dcs_dsd)^2
elow=!dcs_hsq2mn/(!dcs_hom*(tsdm+samperiod)/!dcs_dsd)^2
; Print warning message if incident neutron energy does not
; lie between "ehigh" and "elow".
if (not (elow lt e0 and e0 lt ehigh)) then begin
	iwarning=iwarning+1
	warnings[iwarning]='Unexpected minimum time sample-detector.'
	iwarning=iwarning+1
	warnings[iwarning]=' (Elastic time of flight is excluded).'
	iwarning=iwarning+1
	warnings[iwarning]=' Problem has NOT been corrected.'
endif
;
; Determine plot limits.
efmax=e0*rat
qmax=sqrt((e0+efmax-2*sqrt(e0*efmax)*cos(phimax*!dtor))*conversion)
;
; If plot is zoomed use plot limits defined by mouse movement.
if (not dozoom) then begin
	xlim=[e0-efmax,e0]
	ylim=[0,qmax*Aunit[iunit]]
endif else begin
	xlim=[x1[0]<x2[0],x1[0]>x2[0]]
	ylim=[x1[1]<x2[1],x1[1]>x2[1]]
endelse
zoomed=dozoom
;
; Plot the frame.
plot,xlim,ylim,xtitle='E0-Ef (meV)',ytitle='Q ('+unitname[iunit]+'-1)'$
	,/nodata,/ynozero,color=1
;
; Plot y axis at x=0 (elastic energy)
plots,[0,0],[0,!y.crange[1]],linestyle=4,color=1
;
; If they appear within the plot limits, plot lines at ehigh and/or elow,
; corresponding to first and last time channels respectively.
if (ehigh lt efmax) then $
	plots,[e0-ehigh,e0-ehigh],[0,!y.crange[1]],linestyle=0,color=2
if (elow lt efmax) then $
	plots,[e0-elow,e0-elow],[0,!y.crange[1]],linestyle=0,color=2
;
; Plot more lines corresponding to later frames.
for k=2,4 do begin
	elowk=!dcs_hsq2mn/(!dcs_hom*(tsdm+k*samperiod)/!dcs_dsd)^2
	if (elowk lt efmax) then $
		plots,[e0-elowk,e0-elowk],[0,!y.crange[1]],linestyle=2,color=2
endfor
;
; Scattered energies and energy transfers.
ef=indgen(nef)*efmax/(nef-1)
et=e0-ef
;
; For each value of phi determine a set of Q values and plot locus.
for phi=phimin,phimax+dphi*0.01,dphi do begin
	cphi=cos(phi*!dtor)
	q=sqrt((e0+ef-2*sqrt(e0*ef)*cphi)*conversion)*Aunit[iunit]
	oplot,et,q,color=1
endfor
;
; Write some stuff on the plot.
xlims=!x.crange
ylims=!y.crange
xpos=xlims[0]+(xlims[1]-xlims[0])*0.625
xyouts,xpos,0.95*ylims[1]," Wavelength ="+strcompress(wl),color=1
xyouts,xpos,0.9*ylims[1]," T_SD(min) ="+strcompress(tsdm),color=1
xyouts,xpos,0.85*ylims[1],'Speed ratio = '+strcompress(string(snum)+'/'+string(sdenom)),color=1
;
; If zoom rectangle is to be drawn, draw it.
zdrawn=0
if (drawzoom) then begin
	xx=[x1[0],x1[0],x2[0],x2[0],x1[0]]
	yy=[x1[1],x2[1],x2[1],x1[1],x1[1]]
	plots,xx,yy,linestyle=7,color=1
	zdrawn=1
endif
;
; "skip" is true if it's a plot to the printer.
if (skip) then begin
; Revert to color table in existence at start of procedure.
	tvlct,oldct
	return
endif
;
; Update various quantities.
widget_control,rattext,set_value=string(rat,format='(f6.3)')
widget_control,phiminslider,set_value=phimin
widget_control,phimaxslider,set_value=phimax
;
; Minimum and maximum values of Q for elastic scattering.
qelmin=sqrt(2*e0*(1-cos(phimin*!dtor))*conversion)*Aunit[iunit]
qelmax=sqrt(2*e0*(1-cos(phimax*!dtor))*conversion)*Aunit[iunit]
;
; Determine flux at sample and elastic energy resolution.
flux=dcs_jcc_flux(wl,rmode,npsptr)
flux=flux/sdenom*(20000/mspeed)
elres=dcs_jcc_resn(wl,wl,rmode,mspeed)
;
; Update message section.
widget_control,messagetext,set_value=['lambda = '+string(wl,format='(f6.3)')+' A',$
	'  (i.e. '+string(wl*0.1,format='(f6.4)')+' nm)',$
	'k0 = '+string(2*!pi/wl,format='(f6.3)')+' A-1',$
	'  (i.e. '+string(20*!pi/wl,format='(f6.2)')+' nm-1)',$
	' ',$
	'Flux at sample: ',$
	string(round(flux),format='(i6)')+' n/cm2/s',$
	'Elastic energy resolution',$
	string(elres,format='(f6.1)')+' ueV',$
	' ',$
	'E0 = '+string(e0,format='(f6.3)')+' meV',$
	'Elastic scattering Q range:',$
	'Q_min = '+string(qelmin,format='(f6.3)')+' '+unitname[iunit]+'-1',$
	'Q_max = '+string(qelmax,format='(f6.3)')+' '+unitname[iunit]+'-1']
;
; Update information about speeds and periods etc.
widget_control,speedtext,set_value=strcompress(mspeed,/remove_all)
widget_control,rmodetext,set_value=strcompress(rmode,/remove_all)
widget_control,srattext,set_value=strcompress(sdenom,/remove_all)
widget_control,tsdmtext1,set_value=strcompress(tsdm,/remove_all)
widget_control,periodstext,set_value=[$
	'Master period = '+string(long(mperiod),format='(i7)')+' us',$
	'Period at sample = '+string(long(samperiod),format='(i7)')+' us',$
	'Slow chopper period = '+string(long(sc_period),format='(i7)')+' us',$
	'S.C. speed ratio = '+strcompress(string(snum)+'/'+string(sdenom)),$
	'S.C. speed = '+string(long(sc_speed),format='(i7)')+' rpm']
widget_control,elimitstext,set_value=['Range of energy transfers',$
	'min E0-Ef = '+string(e0-ehigh,format='(f7.2)')+' meV',$
	'max E0-Ef = '+string(e0-elow,format='(f7.2)')+' meV']
;
; Write any warning messages.
widget_control,warningstext,set_value=warnings
;
; Revert to color table in existence at start of procedure.
tvlct,oldct
;
end


;************************************************************************************************
pro DCSToolsPlanner,event
;************************************************************************************************
;
compile_opt strictarr
;
; A program to help people plan DCS experiments.
;
common constants,conversion
common units,iunit,Aunit,unitname
common energies,e0
common cursor_related,postext,restext
common dependent_values,messagetext
common dependent_stuff,periodstext,elimitstext,warningstext
common modifiable_values,rattext,phiminslider,phimaxslider,$
	speedtext,rmodetext,srattext,tsdmtext1
common modifiable_stuff,mspeed,rmode,israt,sdenom,tsdm,samperiod,nout,tchanmethod
common zoom_related,x1,x2,x1r,x2r,drawzoom,dozoom,zoomed,zdrawn,xlim,ylim
;
widget_control,event.top,get_uvalue=statePtr
davePtr=(*statePtr).davePtr
;
dcs_sysvars,davePtr=davePtr
;
tvlct,r,g,b,/get
rgbptr=ptr_new({r:r,g:g,b:b})
;
hbarsq2mn=!dcs_hsq2mn/(2*!pi)^2
conversion=1/hbarsq2mn
;
; Plot to a Window.
case !VERSION.OS_FAMILY of
	"Windows": set_plot,"WIN"
	"unix": set_plot,"X"
	"MacOS": set_plot,"MAC"
	else: stop,"Unsupported operating system."
endcase
;
;dcs_sysdep,fonts=fonts
;fonts=fonts[0]
;
screensize=!screensize
;
; Starting values of input parameters
wl=4.8
phimin=10
dphi=10
phimax=140
rat=3.0
nef=101

; Read in or define the overall size of the widget.
if (keyword_set(xsizekar)) then xsk=xsizekar else xsk=screensize[0]*0.9
if (keyword_set(ysizekar)) then ysk=ysizekar else ysk=screensize[1]*0.9
if (keyword_set(group_leader)) then group_leader=group_leader $
	else group_leader=""
;
Aunit=[1,10]
unitname=["A","nm"]
;
srattyp=['(m-1)/m','1/m']
tsdmtyp=['Constant dt','Constant dE']
;
; Initial values.
iunit=0
wl=4.1
rat=3.0
phimin=10
dphi=10
phimax=140
mspeed=20000
israt=0
;snum=1
sdenom=1
rmode=1
tsdm=2800
tchanmethod=0
nout=1000
;
; Define base widget and other widgets.
tlb=widget_base(title="Kinematically Allowed Region",$
	/column,xsize=xsk,ysize=ysk,xoffset=screensize[0]*0.05,$
	group_leader=event.top,/modal)
	toprow=widget_base(tlb,/row,/align_left,frame=2,$
		xsize=0.99*xsk,ysize=0.49*ysk)
	bottomrow=widget_base(tlb,/row,/align_left,frame=2,$
		xsize=0.99*xsk,ysize=0.49*ysk)
		buttonbase=widget_base(toprow,/row,frame=2,ysize=0.49*ysk)
		messagetext=widget_text(toprow,xsize=20,$
			value=strarr(20),ysize=4)
		inputtext=widget_base(toprow,frame=2,/column,ysize=0.49*ysk)
		outputtext=widget_base(toprow,frame=2,/column,xsize=200,ysize=0.49*ysk)
			otherbuttons=widget_base(buttonbase,/column, /align_center)
					unitsdroplist=widget_droplist(otherbuttons,$
						title='Wavelength unit',value=unitname,$
						event_pro='DCSToolsPlanner_textbuttons')
					lambdabase=widget_base(otherbuttons,/row,frame=2,$
						xsize=140)
						label=widget_label(lambdabase,value='lambda: ')
						lambdatext=widget_text(lambdabase,$
							value=string(wl,format='(f6.3)'),$
							/editable,event_pro='DCSToolsPlanner_textbuttons',xsize=10)
					ratbase=widget_base(otherbuttons,/row,frame=2,xsize=140)
						label=widget_label(ratbase,value='Efmax/E0: ')
						rattext=widget_text(ratbase,$
							value=string(rat,format='(f6.3)'),$
							/editable,event_pro='DCSToolsPlanner_textbuttons',xsize=10)
					phiminbase=widget_base(otherbuttons,/row,frame=2,xsize=120)
						phiminslider=widget_slider(phiminbase,value=phimin,$
							event_pro='DCSToolsPlanner_textbuttons',min=0,max=180,$
							title='phimin (deg)')
					dphibase=widget_base(otherbuttons,/row,frame=2,xsize=120)
						dphislider=widget_slider(dphibase,value=dphi,$
							event_pro='DCSToolsPlanner_textbuttons',min=1,max=30,$
							title='dphi (deg)')
					phimaxbase=widget_base(otherbuttons,/row,frame=2,xsize=120)
						phimaxslider=widget_slider(phimaxbase,value=phimax,$
							event_pro='DCSToolsPlanner_textbuttons',min=0,max=180,$
							title='phimax (deg)')
				speedbase=widget_base(inputtext,/row,frame=2)
					speedlabel=widget_label(speedbase,$
						value='Master speed (rpm): ')
					speedtext=widget_text(speedbase,$
						value=strcompress(string(mspeed),/remove_all),$
						/editable,event_pro='DCSToolsPlanner_textbuttons',xsize=5)
				sratbase=widget_base(inputtext,/column,frame=2)
					sratbase1=widget_base(sratbase,/row)
						sratlabel1=widget_label(sratbase1,$
							value='Speed ratio method')
						sratdroplist=widget_droplist(sratbase1,$
							title='',value=srattyp,$
							event_pro='DCSToolsPlanner_textbuttons')
					sratbase2=widget_base(sratbase,/row)
						sratlabel2=widget_label(sratbase2,$
							value='Speed ratio denominator')
						srattext=widget_text(sratbase2,$
							value=strcompress(string(sdenom),/remove_all),$
						/editable,event_pro='DCSToolsPlanner_textbuttons',xsize=2)
				rmodebase=widget_base(inputtext,/row,frame=2)
					rmodelabel=widget_label(rmodebase,$
						value='Res''l''n mode (low=1,high=3): ')
					rmodetext=widget_text(rmodebase,$
						value=strcompress(rmode,/remove_all),$
						/editable,event_pro='DCSToolsPlanner_textbuttons',xsize=1)
				tsdmbase=widget_base(inputtext,/col,frame=2)
					tsdmbase1=widget_base(tsdmbase,/row)
						tsdmlabel1=widget_label(tsdmbase1,value='Min. time Sam-Det: ')
						tsdmtext1=widget_text(tsdmbase1,value=strcompress(tsdm,/remove_all),$
							/editable,event_pro='DCSToolsPlanner_textbuttons',xsize=6)
					tsdmbase2=widget_base(tsdmbase,/row)
						tsdmlabel2=widget_label(tsdmbase2,value='Channel width method')
						tsdmdroplist=widget_droplist(tsdmbase2,$
							title='',value=tsdmtyp,event_pro='DCSToolsPlanner_textbuttons')
					tsdmbase3=widget_base(tsdmbase,/row)
						tsdmlabel3=widget_label(tsdmbase3,value='Number of valid time channels: ')
						tsdmtext3=widget_text(tsdmbase3,value=strcompress(nout),$
							/editable,event_pro='DCSToolsPlanner_textbuttons',xsize=6)
				periodstext=widget_text(outputtext,ysize=5,value=strarr(5))
				elimitstext=widget_text(outputtext,ysize=3,value=strarr(3))
				warningstext=widget_text(outputtext,xsize=20,ysize=8,value=strarr(20),/scroll)
		draw=widget_draw(bottomrow,xsize=0.625*xsk,ysize=0.48*ysk,$
			/button_events,/motion_events,event_pro='DCSToolsPlanner_mouseposition')
		cmbase=widget_base(bottomrow,/row,$
			xsize=xsk*0.35,ysize=0.48*ysk)
			cursorbase=widget_base(cmbase,/column,frame=2,xsize=xsk*0.16)
				postext=widget_text(cursorbase,ysize=6,value=strarr(6))
				restext=widget_text(cursorbase,ysize=2,value=strarr(2))
			mainbuttons=widget_base(cmbase,/column,frame=2,xsize=xsk*0.16)
				gob=widget_button(mainbuttons,$
					value='Recalculate',event_pro='DCSToolsPlanner_textbuttons')
				zoomb=widget_button(mainbuttons,$
					value='Zoom in',event_pro='DCSToolsPlanner_zoombutton')
				psb=widget_button(mainbuttons,$
					value='Print',event_pro='DCSToolsPlanner_printbutton')
				tsdmb=widget_button(mainbuttons,$
					value='Save tchan widths',event_pro='DCSToolsPlanner_tchanbutton')
				t2eb=widget_button(mainbuttons,$
					value='Relate t-channel to E-transfer(s)',event_pro='DCSToolsPlanner_t2ebutton')
				savpb=widget_button(mainbuttons,$
					value='Save parameters',event_pro='DCSToolsPlanner_textbuttons')
				respb=widget_button(mainbuttons,$
					value='Restore parameters',event_pro='DCSToolsPlanner_textbuttons')
				doneb=widget_button(mainbuttons,$
					value='EXIT',event_pro='DCSToolsPlanner_exitbutton')

; Realize the widget
widget_control,tlb,/realize
;
widget_control,draw,get_value=winid
wset,winid
;
; Initial settings of droplists.
widget_control,unitsdroplist,set_droplist_select=iunit
widget_control,sratdroplist,set_droplist_select=israt
widget_control,tsdmdroplist,set_droplist_select=tchanmethod
;
; Plot the kinematically allowed region.
nef=101
dozoom=0
drawzoom=0
zoomed=0
;
dcs_getnps,npsptr
DCSToolsPlanner_plot_kar,wl,phimin,dphi,phimax,rat,nef,skip=0,npsptr
;
; Define the state variable.
state={lambdatext:lambdatext,$
	wl:wl,$
	unitsdroplist:unitsdroplist,$
	rattext:rattext,$
	rat:rat,$
	phiminslider:phiminslider,$
	phimin:phimin,$
	phimaxslider:phimaxslider,$
	phimax:phimax,$
	dphislider:dphislider,$
	dphi:dphi,$
	nef:nef,$
	psb:psb,$
	t2eb:t2eb,$
	savpb:savpb,$
	respb:respb,$
	speedtext:speedtext,$
	mspeed:mspeed,$
	rmodetext:rmodetext,$
	rmode:rmode,$
	srattext:srattext,$
	sratdroplist:sratdroplist,$
	israt:israt,$
	sdenom:sdenom,$
	tsdmtext1:tsdmtext1,$
	tsdm:tsdm,$
	tsdmdroplist:tsdmdroplist,$
	tchanmethod:tchanmethod,$
	tsdmtext3:tsdmtext3,$
	nout:nout,$
	periodstext:periodstext,$
	elimitstext:elimitstext,$
	warningstext:warningstext,$
	npsptr:npsptr}
;
widget_control,tlb,SET_UVALUE=state
;
; Manage the widget
xmanager,'DCSToolsPlanner',tlb,$
	/no_block,group_leader=group_leader
;
dave_makeDavePtr,davePtr=davePtr
(*statePtr).davePtr=davePtr
;
tvlct,(*rgbptr).r,(*rgbptr).g,(*rgbptr).b
ptr_free,rgbptr
;
end
